#include <xc.h>
//#include "font2.c"

#define RS PORTAbits.RA1  //display text - command  
#define EN PORTCbits.RC4  //display enable 

#define CMD 0  //command
#define DAT 1    //data

static const char dBV2[]={
10, 11, 13, 14, 16, 18, 20, 22, 25, 28,    
31, 35, 40, 45, 50, 56, 63, 70, 79, 89,
100, 113, 126, 142, 160, 178, 200     
}; 

static const char dBV1[]={
22, 23, 25, 26, 28, 31, 33, 36, 39, 42,    
46, 50, 55, 60, 66, 73, 81, 90, 99, 110,
122, 136, 152, 169, 188, 220, 244     
};


//static const char Sinp[] = {0, 20,  40, 60, 78, 98, 116, 133, 150, 166, 180, 194,206,  217, 227, 236, 243, 248, 252, 254 };

static const char Sinp[] = {255, 252, 243, 227, 206, 180, 150, 116, 78, 40, 0 };

//static const char Sinp[] = {0, 40, 78, 116, 150, 180, 206, 227, 243, 252, 255};
static const char Modt[] = {0,94, 140, 168, 187, 200, 210, 218, 224, 230, 234, 237, 240, 243, 245, 247, 249, 251, 253, 254, 255 };


const char * const BaudText[] = {
    "300", "1200", "2400", "4800", "9600", "19200", "38400", "57600", "115200", "485", "USB"
};
    

static const char W1250[] = {
    0xE1, 0xE8, 0xEC, 0xED, 0xF8, 0x9A, 0xB9, 0xFA, 0xFD, 0xF2, 0xB0, 0xB5, //          m
    8,       9,  0xA,  0xB,  0xC,  0xD, 0xD,  0xE,  0xF, 0xEE, 0xDF, 0xE4
};

static const char Baud[] = {
    0x04, 0x0D, 0x40, 0x03, 0xA0, 0x01, 0xCF, 0x00, 0x67, 0x00, 0x33, 0x00, 0x19, 0x00, 0x10, 0x00, 0x08, 0x00
}; //300,       1200,       2400,       4800,       9600,       19200,      38400,      57600,      115200

const char * const Text[]= {
     "Reset     Zapsat", "Kalibrovat?      "
};
//static const char ASCII[];
//static const char bargr[][24];

 /*
void Dport(char bt) {

   if (bt & 1)PORTCbits.RC0 = 1;
    else PORTCbits.RC0 = 0;
    if (bt & 2)PORTCbits.RC1 = 1;
    else PORTCbits.RC1 = 0;
    if (bt & 4)PORTCbits.RC2 = 1;
    else PORTCbits.RC2 = 0;
    if (bt & 8)PORTCbits.RC3 = 1;
    else PORTCbits.RC3 = 0;
   
    PORTC &= 0xF0;
    PORTC |= bt&0x0F;
}
*/

void Delay(int ms) { //ms
   // char tms = ms;
    while (ms) {
        _delay(4000);
        ms--;
    }
}//

void Sdelay(char dl) {
    char ddl = dl;
    while (ddl) {
        _delay(32); //8us
        ddl--;
    }
}//
void LCD_Start(char ch) {
    //Dport(ch);
     PORTC &= 0xF0;
    PORTC |= ch;
    EN = 0;
    EN = 1;
    if (ch == 3) Delay(4); //4 ms
    else Sdelay(5); //40us
}//
void LCD_Chr(char dchr, char dc) {
    char i;

    // if(dc && (dchr == '')) dchr = 0xDF;  //krouzek

    if (dchr > 0x7F && dc) {
        for (i = 0; i < 12; i++)if (dchr == W1250[i]) {
                dchr = W1250[i + 12];
                break;
            }
    };

    RS = dc; //RS = 1(data)
    //Dport((dchr & 0xF0) >> 4);
     PORTC &= 0xF0;
    PORTC |= (dchr >> 4) & 0x0F;
    EN = 1;
    EN = 0;
    //Dport(dchr & 0x0F);
    PORTC &= 0xF0;
    PORTC |= dchr & 0x0F;
    EN = 1;
    EN = 0;
    if (dc == CMD && (dchr < 8)) Delay(2); // __delay_ms(2);
    else Sdelay(5); //40us
    EN = 1;

}//
void LCD_Init(void) {
    Delay(40);

    EN = 1;
    RS = 0;
    LCD_Start(3); //ekej > 4,1ms
    LCD_Start(3);
    LCD_Start(3);
    LCD_Start(2);

    LCD_Chr(0x28, CMD); //dva rdky
    LCD_Chr(0x10, CMD); //cursor left
    LCD_Chr(0x0E, CMD); //cursor on, disp on
    LCD_Chr(0x06, CMD); //incrementace
    LCD_Chr(0x01, CMD); //smazat LCD

}//
void LCD_Strx(char *str) {
    while (*str != 0)
        LCD_Chr(*str++, DAT);
}//
void Fonts(char beg, char len, char *font){
    char i;
 LCD_Chr((0x40 + beg), CMD); //adresa ram
    for (i = 0; i < len; i++)
        LCD_Chr(font[i], DAT);
}//

void Bargr(char pchr){
     signed char bx;
     char i = 0;
    for (bx = pchr; bx > 2; bx -= 3) {
        LCD_Chr(0xF, DAT);
        i++;
    }
    if (bx == 2) {
        LCD_Chr(0xE, DAT);
        i++;
    } else if (bx == 1) {
        LCD_Chr(0xD, DAT);
        i++;
    }
    for (; i < 20; i++)LCD_Chr(0x20, DAT);
}//

